from EStat.Templating import *

class TemplateGenericQuiz(Template):
    '<p>Quiz template - developed for use with eBooks (based on QuizMultiQNoExtraFeedback).</p><ul><li>Allows for multiple questions, with multiple-choice, multiple-answer, and open-answer formats.</li><li>Returns the total number correct, and separately the identity of correct/incorrect answers.</li></ul>'

    tags = [ 'eBook' ]
    engines = ['Python_script']

    inputs = '''
NumQs = Integer('How many questions?')
TryAgain = Boolean('If they did not get all of the questions correct, do you want to invite them to try again?')
for i in range(0, int(NumQs)):
    context['Q' + str(i + 1) + '_text'] = Text('What is question ' + str(i + 1) + '?')
    context['Q' + str(i + 1) + '_multi'] = Boolean('Is Q' + str(i + 1) + ' multiple choice?')
    if context['Q' + str(i + 1) + '_multi']:
        context['Q' + str(i + 1) + '_responsetype'] = Text('In what format do you want the responses to be presented for Q' + str(i + 1) + '? (Choose Checkbox if more than one answer to be selected)', ['Drop-down box', 'Radio buttons', 'Checkbox'])
        context['Q' + str(i + 1) + '_numanswers'] = Integer('How many possible answers for Q' + str(i + 1) + '?')
        for j in range(0, int(context['Q' + str(i + 1) + '_numanswers'])):
            context['Q' + str(i + 1) + '_answer' + str(j + 1)] = Text('Q' + str(i + 1) + ' - answer ' + str(j + 1))
        context['Q' + str(i + 1) + '_answerlist']=[]
        for j in range(0, int(context['Q' + str(i + 1) + '_numanswers'])):
            context['Q' + str(i + 1) + '_answerlist'].append(str(context['Q' + str(i + 1) + '_answer' + str(j + 1)]))
        if context['Q' + str(i + 1) + '_responsetype'] == 'Checkbox':
            context['Q' + str(i + 1) + '_correctanswer'] = List('What are the correct answers for Q' + str(i + 1) +'?', context['Q' + str(i + 1) + '_answerlist'])
        else:
            context['Q' + str(i + 1) + '_correctanswer'] = Text('What is the correct answer for Q' + str(i + 1) +'?', context['Q' + str(i + 1) + '_answerlist'])
        UserQ=str(context['Q' + str(i + 1) + '_text'])
        UserAnswerList=context['Q' + str(i + 1) + '_answerlist']
        if context['Q' + str(i + 1) + '_responsetype'] == 'Drop-down box':
            context['Q' + str(i + 1) + '_useranswer'] = Text(UserQ,UserAnswerList)
        if context['Q' + str(i + 1) + '_responsetype'] == 'Radio buttons':
            context['Q' + str(i + 1) + '_useranswer'] = TextRadio(UserQ,UserAnswerList)
        if context['Q' + str(i + 1) + '_responsetype'] == 'Checkbox':
            context['Q' + str(i + 1) + '_useranswer'] = ListCheckbox(UserQ,UserAnswerList)
    else:
        context['Q' + str(i + 1) + '_correctanswer'] = Text('What is the correct answer for Q' + str(i + 1) +'?')
        context['Q' + str(i + 1) + '_useranswer'] = Text(str(context['Q' + str(i + 1) + '_text']))

'''

    pythonscript = '''
from EStat.Templating import HTMLOutput
answer = []
total = []
numcorrect = 0
for i in range(0, int(NumQs)):
    if context['Q' + str(i + 1) + '_multi'] and context['Q' + str(i + 1) + '_responsetype'] == 'Checkbox':
##currently this splits useranswer (which has class ListCheckbox) into a list, but really it should already know it's a list!
        context['Q' + str(i + 1) + '_answerlist']=set(str(context['checkQ' + str(i + 1) + '_useranswer'][0]).split(','))
        context['Q' + str(i + 1) + '_correctanswers'] = set(context['Q' + str(i + 1) + '_correctanswer'])
    else:
        context['Q' + str(i + 1) + '_answerlist']=set([str(context['Q' + str(i + 1) + '_useranswer'])])
        context['Q' + str(i + 1) + '_correctanswers'] = set([str(context['Q' + str(i + 1) + '_correctanswer'])])
    if i>0:
        answer.append('<hr>')
    if set(context['Q' + str(i + 1) + '_correctanswers']) == set(context['Q' + str(i + 1) + '_answerlist']):
        numcorrect=(numcorrect+1)
        answer.append('<strong>CORRECT <img src="smile.png" alt="Smiling face" title="Smiling face"/> - well done!</strong></p>')
    else:
        answer.append('<strong>INCORRECT</strong> <img src="thoughtful.png" alt="Thoughtful face" title="Thoughtful face"/></p>')
    answer.append('<p align = "left">Your answer: <strong>' + str(context['Q' + str(i + 1) + '_useranswer']) + '</strong></p><p align = "left">...for <strong>"' + str(context['Q' + str(i + 1) + '_text']) + '"</strong> was')
    if set(context['Q' + str(i + 1) + '_correctanswers']) == set(context['Q' + str(i + 1) + '_answerlist']):
        answer.append(' correct - <strong>well done!</strong></p>')
    else:
        answer.append(' not right.</p>')
total.append('<p><strong>You got ' + str(numcorrect) + ' out of ' + str(int(NumQs)) + ' correct... ')
if int(NumQs)>numcorrect:
    if TryAgain:
        total.append('</strong>why not try again and see if you can get them <em>all</em> correct, before looking at the answers on the next page?</p>')
    else:
        total.append('</strong></p>')
else:
    total.append('well done!</strong></p>')
outputs['feedback'] = HTMLOutput("".join(answer), description = 'Answer to the question')
outputs['totalQs'] = HTMLOutput("".join(total), description = 'Total number correct')

'''
