# Copyright (c) 2013, University of Bristol and University of Southampton.

from EStat.Templating import Template

class StataRegress(Template):
    'Fits a 1 level Normal multiple regression model in Stata, using the regress command - developed for use with eBook.'

    __version__ = '1.0.0'

    tags = [ 'Model', '1-Level', 'Normal']
    engines = ['Stata_model']

    inputs = '''
y = DataVector('Response: ')
x = DataMatrix('Explanatory variables: ')
for var in x:
    context[var + '_cat'] = Boolean('Is ' + var + ' categorical? ', default=False)
'''

#if want to return results, via parmest, without reference category (has missing values/empty cells)...
#then can use xi: regress var1 var2 i.var3 - i.e. just change the first line to xi: regress ${y} \\
#...but for some reason can't get templateX-results.dta in ebooktest when use xi

#For London? cd ${directory}
  
    statascript = '''
xi: regress ${y} \\
% for p in x:
% if context[p + '_cat']:
 i.${p}\\
% else:
 ${p}\\
% endif 
% endfor
##always remove the intercept
##noconstant

##capture which parmest
##if _rc ssc install parmest
##parmest, norestore
'''
